<?php
$mode = isset($_GET['mode']) ? $_GET['mode']: '';

$config['_metatags'] = isset($_meta) ? (array)$_meta: array();
$config['_metatags']['page'] = isset($page) && $page > 1 ? _t(' - Page %page', array('%page' => (int) $page)) : '';

$langs = array();
if (isset($currentLang) && $currentLang != $config['default_language']) {
    $langs[$currentLang] = $currentLang;
    $config['_metatags'] += array(
        'default_header_title' => $config["default_header_title__{$currentLang}"],
        'default_meta_title' => $config["default_meta_title__{$currentLang}"],
        'default_meta_description' => $config["default_meta_description__{$currentLang}"],
        'default_meta_keywords' => $config["default_meta_keywords__{$currentLang}"],
        'default_meta_robots' => $config["default_meta_robots__{$currentLang}"],
        'sitename' => (isset($config["sitename__{$currentLang}"]) && $config["sitename__{$currentLang}"] != "") ? $config["sitename__{$currentLang}"] : $config['sitename'],
    );
} else {
	$config['default_header_title'] = isset($config['default_header_title']) ? $config['default_header_title'] : ""; 
	$config['default_meta_title'] = isset($config['default_meta_title']) ? $config['default_meta_title'] : ""; 
	$config['default_meta_description'] = isset($config['default_meta_description']) ? $config['default_meta_description'] : ""; 
	$config['default_meta_keywords'] = isset($config['default_meta_keywords']) ? $config['default_meta_keywords'] : ""; 
	$config['default_meta_robots'] = isset($config['default_meta_robots']) ? $config['default_meta_robots'] : ""; 
	$config['sitename'] = isset($config['sitename']) ? $config['sitename'] : ""; 
	
    $config['_metatags'] += array(
        'default_header_title' => $config['default_header_title'],
        'default_meta_title' => $config['default_meta_title'],
        'default_meta_description' => $config['default_meta_description'],
        'default_meta_keywords' => $config['default_meta_keywords'],
        'default_meta_robots' => $config['default_meta_robots'],
        'sitename' => $config['sitename'],
    );
	$langs[$config['default_language']] = $config['default_language'];
}



$metatags = dbRow("SELECT * FROM `metatags` WHERE `controller` = '" . mysqli_real_escape_string($dblink, $thisController) . "' AND `mode` = '" . ($mode != "" ? mysqli_real_escape_string($dblink, $mode) : ($thisController === 'index' ? 'default' : '')) . "' AND `language` IN ('" . implode("','", $langs) . "') ORDER BY FIELD(`language`, '" . implode("','", $langs) . "')", false);
if (!is_array($metatags)) {
    $metatags_core = dbRow("SELECT * FROM `metatags` WHERE `controller` = '" . mysqli_real_escape_string($dbconn, $thisController) . "' AND `mode` = '" . ($mode != "" ? mysqli_real_escape_string($dbconn, $mode) : ($thisController === 'index' ? 'default' : '')) . "' AND `language` = '" . $config['core_language'] . "'", false);
    if (is_array($metatags_core)) {
        unset($metatags_core['record_num']);
        $metatags_core['language'] = $currentLang;
        $metatags = dbInsert('metatags', $metatags_core, true, false, array(), array(), true);
    } 
}

$langSelect = '';
$langJoin = '';
$langWhere = '';




$config['_metatags']['description'] = htmlentities(truncate(trim($config['_metatags']['description'] . ' ' . $config['_metatags']['meta_description']), 156), ENT_QUOTES, 'UTF-8');
if ($config['_metatags']['description'] == '') {
    $config['_metatags']['description'] = htmlentities($config['_metatags']['default_meta_description'], ENT_QUOTES, 'UTF-8');
}
$config['_metatags']['keywords'] = htmlentities(truncate(trim($config['_metatags']['keywords'] . ' ' . $config['_metatags']['meta_keywords']), 156), ENT_QUOTES, 'UTF-8');
if ($config['_metatags']['keywords'] == '') {
    $config['_metatags']['keywords'] = htmlentities($config['_metatags']['default_meta_keywords'], ENT_QUOTES, 'UTF-8');
}

/* Override certain metatags for specific index modes */
if ($thisController === 'performer') {
	$username = mysqli_real_escape_string($dblink,$_GET['username']); 
	$site = mysqli_real_escape_string($dblink,$_GET['site']); 
	$siteData = dbRow("SELECT record_num,name FROM paysites WHERE slug = '".$site."'");

    $_user = dbRow("SELECT `username`, custom_metadesc, custom_title FROM `performers` WHERE username = '".$username."' AND site = '".$siteData['record_num']."'", true, 300);
	if(!is_array($_user)) { 
		$username = str_replace(" ","-",$username); 
		$_user = dbRow("SELECT `username`, custom_metadesc, custom_title FROM `performers` WHERE username = '".$username."' AND site = '".$siteData['record_num']."'", true, 300);
	}
	if(isset($_user['custom_metadesc']) && !empty($_user['custom_metadesc'])) { 
		$config['_metatags']['description'] = $_user['custom_metadesc']; 
		$metatags['meta_description'] = $_user['custom_metadesc']; 
	}
    $config['_metatags']['username'] = htmlentities(ucwords($_user['username']), ENT_QUOTES, 'UTF-8');
	$config['_metatags']['site_title'] = htmlentities(ucwords($siteData['name']), ENT_QUOTES, 'UTF-8');
   
}



$replacement = array();
foreach ($config['_metatags'] as $metatag_key => $metatag_value) {
    $replacement['{{' . strtoupper($metatag_key) . '}}'] = $metatag_value;
}

if (is_array($metatags)) {
    foreach ($metatags as &$meta) {
        $meta = strtr($meta, $replacement);
    }
    $title = $metatags['meta_title'];
	$config['default_meta_title'] = $metatags['meta_title'];
    $headertitle = $metatags['header_title'];
	$config['default_header_title'] = $metatags['header_title'];
    $metadescription = $metatags['meta_description'];
	$config['default_meta_description'] = $metatags['meta_description'];
    $metakeywords = $metatags['meta_keywords'];
	$config['default_meta_keywords'] = $config['default_meta_keywords'];
    $metarobots = $metatags['robots'] ? $metatags['robots'] : $config['default_meta_robots'];
	$config['default_meta_robots'] = $metatags['robots'] ? $metatags['robots'] : $config['default_meta_robots'];

} else {
    $title = $config['default_meta_title'];
    $headertitle = $config['default_header_title'];
    $metadescription = $config['default_meta_description'];
    $metakeywords = $config['default_meta_keywords'];
    $metarobots = $config['default_meta_robots'];
}

//This is a bit complicated. It's to dynamically build the header titles.
$genderTranslation = array("f"=>"Female", "m"=>"Male", "c"=>"Couple", "t"=>"Trans");
if(is_array($_GET['status'])) { 
	$concatStatus = htmlentities(ucwords(implode($withStatusSeparator,$_GET['status']))); 
}
if(is_array($_GET['hair'])) { 
	$concatHair = htmlentities(ucwords(implode($withHairSeparator,$_GET['hair']))); 
}
if(is_array($_GET['ethnicity'])) { 
	$concatEthnicity = htmlentities(ucwords(implode($withEthnicitySeparator,$_GET['ethnicity']))); 
}
if(is_array($_GET['gender'])) { 
	foreach($_GET['gender'] as $g) { 
		$metaTagOutGenderTmp[] = $genderTranslation[$g];
	}
	$concatGender = htmlentities(ucwords(implode($withGenderSeparator,$metaTagOutGenderTmp))); 
}
if(is_array($_GET['tags'])) { 
	$concatTags = htmlentities(ucwords(implode($withTagsSeparator,$_GET['tags']))); 
}
if(is_array($_GET['age'])) { 
	$concatAge = htmlentities(ucwords(implode($withAgeSeparator,$_GET['age']))); 
}
if(is_array($_GET['sites'])) { 
	$tagData = dbQuery("SELECT name FROM paysites WHERE record_num IN (".mysqli_real_escape_string($dblink,implode($_GET['sites'],",")).")");

	foreach($tagData as $t) { 
		$tagDataOut[] = $t['name']; 
	}
	$concatSites = htmlentities(ucwords(implode($withSiteSeparator,$tagDataOut))); 
}

if(isset($concatStatus)) { 
	$withStatus = str_replace("{concatenatedStatus}",$concatStatus,$withStatus); 
} else { 
	$withStatus = "";
}
if(isset($concatTags)) { 
	$withTags = str_replace("{concatenatedTags}",$concatTags,$withTags); 
} else { 
	$withTags = "";
}
if(isset($concatEthnicity)) { 
	$withEthnicity = str_replace("{concatenatedEthnicity}",$concatEthnicity,$withEthnicity); 
} else { 
	$withEthnicity = "";
}
if(isset($concatGender)) { 
	$withGender = str_replace("{concatenatedGender}",$concatGender,$withGender); 
} else { 
	$withGender = "";
}
if(isset($concatHair)) { 
	$withHair = str_replace("{concatenatedHair}",$concatHair,$withHair); 
} else { 
	$withHair = "";
}
if(isset($concatAge)) { 
	$withAge = str_replace("{concatenatedAge}",$concatAge,$withAge); 
} else { 
	$withAge = "";
}
if(isset($concatSites)) { 
	$withSite = str_replace("{concatenatedSites}",$concatSites,$withSite); 
} else { 
	$withSite = "";
}
$dynamicSearch = array("{withStatus}", "{withTags}", "{withEthnicity}", "{withGender}", "{withHair}","{withAge}","{withSite}");
$dynamicReplace = array($withStatus, $withTags, $withEthnicity, $withGender, $withHair, $withAge, $withSite); 
//EOF


if(($thisController == 'index' || $thisController == 'router')) { 
	if(is_array($_GET['tags'])) {
		$masterTag = trim(mysqli_real_escape_string($dblink,$_GET['tags'][0]));
		$tagData = dbRow("SELECT * FROM niches WHERE name = '$masterTag'");
		if(isset($tagData['metatitle']) && !empty($tagData['metatitle'])) { 
			$title = $tagData['metatitle']; 
		} else { 
			//$title = str_replace("{tag}",ucwords(htmlentities($masterTag)),$tagDefaultTitle); 
			$title = str_replace($dynamicSearch, $dynamicReplace, $dynamicTitle);
		}
		
		if(isset($tagData['metaheader']) && !empty($tagData['metaheader'])) { 
			$headertitle = $tagData['metaheader']; 
		} else { 
			//$headertitle = str_replace("{tag}",ucwords(htmlentities($masterTag)),$tagDefaultHeaderTitle); 
			$headertitle = str_replace($dynamicSearch, $dynamicReplace, $dynamicHeaderTitle);
		}
		
		if(isset($tagData['metakw']) && !empty($tagData['metakw'])) { 
			$metakeywords = $tagData['metakw']; 
		} else { 
			$metakeywords = str_replace($dynamicSearch, $dynamicReplace, $dynamicMetaKeywords);
		}
		
		if(isset($tagData['metadesc']) && !empty($tagData['metadesc'])) { 
			$metadescription = $tagData['metadesc']; 
		} else { 
			$metadescription = str_replace($dynamicSearch, $dynamicReplace, $dynamicMetaDesc);
		}
		
		if(isset($tagData['description']) && !empty($tagData['description'])) { 
			$data['custom_text'] = $tagData['description'];
		}
	} elseif(is_array($_GET['gender']) || is_array($_GET['status']) || is_array($_GET['ethnicity']) || is_array($_GET['hair']) || is_array($_GET['sites']) || is_array($_GET['age'])) { 
		$title = str_replace($dynamicSearch, $dynamicReplace, $dynamicTitle);
		$headertitle = str_replace($dynamicSearch, $dynamicReplace, $dynamicHeaderTitle);
		$metakeywords = str_replace($dynamicSearch, $dynamicReplace, $dynamicMetaKeywords);
		$metadescription = str_replace($dynamicSearch, $dynamicReplace, $dynamicMetaDesc);
	} else { 
		if(is_array($data) && isset($_GET['url'])) { 
			$title = $data['title']; 
			$headertitle = $data['headertitle']; 
			$metakeywords = $data['meta_kw'];
			$metadescription = $data['meta_desc'];
		}
	}
}

if($_GET['q']) { 
	$title = str_replace("{q}",ucwords(htmlentities($_GET['q'])),$searchTitle); 
	$headertitle = str_replace("{q}",ucwords(htmlentities($_GET['q'])),$searchHeaderTitle); 
	$metakeywords = str_replace("{q}",ucwords(htmlentities($_GET['q'])),$searchMetaKeywords); 
	$metadescription = str_replace("{q}",ucwords(htmlentities($_GET['q'])),$searchMetaDesc); 
}


if(!$headertitle) { 
	if($_GET['controller'] == 'router') { 
		$headertitle = $config['default_meta_title'];
	}
}